%%% 
%%% multiple simulations of deterministic driver with different inputs (x)
%%%
clf;
clear;

% input range
x = 0:25:600;	

t_end = 10000;
dt = 1;

N1 = length(x);
N2 = t_end/dt;

m = zeros(N1,N2+1);
y = zeros(N1,N2+1);


tmp = zeros(N2+1,1);

for i=1:N1
	tmp(:) = x(i);
	y(i,:) = driver_det(tmp, 0, 0, dt, t_end, 0);     
end;


t = [0:dt:t_end];

points = zeros(N1 * N2, 3); 

i=1;
 
 
for j=1:N1
    for k = 1:N2
        points(i,1) = t(k);
        points(i,2) = x(j);
        points(i,3) = y(j,k);
        i=i+1;
    end
end





clf;
%hold on;


plot3(points(:,1), points(:,2), points(:,3),'.'); 

xlabel('Time [s]');
ylabel('Protein x [nM]');
zlabel('Protein y [nM]');


hold off;
