%%% evaluaties the input logic levels of nor gate
%
% Inputs:
% COL_max, COH_min
% t_end: end of the time interval [0, t_end] (period of simulation)
% dt: monitoring time step size;
% t_start: time at which the measurements start
% plot_on: turns the plotting on
%
% Outputs:
% CIH_min,CIL_max
%
% sample call
% [CIH_min,CIL_max] = nor_inputs(60,750,100000,10,5000,1)
%
function [CIH_min,CIL_max] = nor_inputs(COL_max, COH_min, t_end, dt, t_start, plot_on)


N = t_end/dt;
N_start = round(t_start/dt);

z = zeros(1,N+1);

x = 20;
y = 20;
avg_z = 1000;
while avg_z > COH_min

    z = nor_ssa(t_end,dt,[x y 1 0 0 0 0]',[7],0);

    l = length(z(1,:));
    z_tmp = z(1,N_start:l);
    avg_z = mean(z_tmp);
   
    x = x + 1;
	y = y + 1;
end

CIL_max = x;

if (plot_on == 1)
	t = [0:dt:t_end];
	figure(1)
	plot(t,z(1,:));
end;

x = 700;
y = 700;
avg_z = 0;
while avg_z < COL_max

    z = nor_ssa(t_end,dt,[x y 1 0 0 0 1000]',[7],0);

    l = length(z(1,:));
    z_tmp = z(1,N_start:l);
    avg_z = mean(z_tmp);
   
    x = x - 1;
	y = y - 1;
end

CIH_min = x;

if (plot_on == 1)
	figure(2)
	plot(t,z(1,:));
end;

end


