% simulates  the behaviour of synchronous toggle switch on the basis of stochastic models; each module generates inputs for the next one

% simulation time 
t_end = 200000;
% resolution for plotting
t_step = 10;

% number of time steps
N = t_end/t_step;
% set and reset inputs
set = zeros(1,N+1);
reset = zeros(1,N+1);

t_ = round((t_end/t_step)/20);

reset(:) = 2;
set(:) = 2;

reset(5.4*t_:7*t_) = 1000;
set(10.3*t_:12*t_) = 1000;



t = 0:t_step:t_end;

figure(1)
plot(t,set,'r');
hold on;
plot(t,reset);
xlabel('Time [s]');
ylabel('Protein molecule numbers');
axis([0,t_end,0,1500]);
hold off;

% X = [x, y, z, a, b, DNA_x, DNA_y, DNA_z, DNA_a, DNA_b, b2_DNA_x, x2_DNA_y, y2_DNA_z, z2_DNA_a, a2_DNA_b, mRNA_x, mRNA_y, mRNA_z, mRNA_a, mRNA_b]
X_init = [200, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]';
plot_on = 0;

% synchronization signal
a = repressilator_extended_ssa(t_end,t_step,X_init,[1,2,3,4,5],plot_on);

x = a(1,:);

figure(2)
plot(t,x);
xlabel('Time [s]');
ylabel('Protein molecule numbers');
axis([0,t_end,0,1500]);

% X = [x_i, y_i, x, y, x*, DNA_x, DNA_y, DNA_z, DNA_x*, DNA_y*, DNA_z*, mRNA_x, mRNA_y, mRNA_z, z]
X_init = [0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0]';
plot_on = 0;

input_vals = [x; reset];
% and operation between the syncronization signal and reset input (generates signal i)
r_i = and_driver_ssa_inputs(t_end,t_step,X_init,[4,15], plot_on, [1,2], input_vals);

rep_i = r_i(:,2);
size(r_i)
size(rep_i)

X_init = [0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0]';
plot_on = 0;

% and operation between the syncronization signal and set input (generates signal j)
input_vals = [x; set];
r_j = and_driver_ssa_inputs(t_end,t_step,X_init,[4,15], plot_on, [1,2], input_vals);

rep_j = r_j(:,2);

figure(1)
plot(t,r_i(:,1));
hold on;
plot(t,r_j(:,1),'r');
xlabel('Time [s]');
ylabel('Protein molecule numbers');
axis([0,t_end,0,1500]);
hold off;

figure(3)
plot(t,rep_i);
hold on;
plot(t,rep_j,'r');
xlabel('Time [s]');
ylabel('Protein molecule numbers');
axis([0,t_end,0,1500]);
hold off;

X_init = [1000, 0, 0, 0, 1, 1, 0, 0, 0, 0, 20, 0,]';
input_vals = [rep_i, rep_j]';

size(input_vals)
 
% toggle switch controlled by signals i and j
a = toggle_ssa_inputs(t_end,t_step,X_init,[1,2,3,4], plot_on, [3,4], input_vals);
 
x = a(:,1);
y = a(:,2);

figure(4)
plot(t,x);
hold on;
xlabel('Time [s]');
ylabel('Protein molecule numbers');
plot(t,y,'r');
axis([0,t_end,0,1500]);
hold off;


